<script setup lang="ts">
import _ from 'lodash'
import { storeToRefs } from 'pinia'
import { usePollStore } from '~/store/poll'

const poll = usePollStore()
const {
  inputQuestion,
  inputAnswer,
  inputId,
} = storeToRefs(poll)
let errorMessage = $ref('')
const setErrorMessage = (message: string) => {
  errorMessage = message
  setTimeout(() => (errorMessage = ''), 4000)
}

const addField = () =>
  inputAnswer.value.length === 4 ? setErrorMessage('最大４つの回答が入力できます。') : inputAnswer.value.push('')
const removeField = (id: number) => inputAnswer.value.splice(id, 1)
const resetInput = () => {
  inputQuestion.value = ''
  inputAnswer.value = ['', '']
  inputId.value = ''
  poll.$patch({ pollInput: false })
}
const submit = () => {
  if (inputAnswer.value.length < 2) {
    setErrorMessage('最低 2 つの回答が必要')
    return
  }
  if (_.some(inputAnswer.value, i => i === '') || inputQuestion.value === '') {
    setErrorMessage('入力してください')
    return
  }
  if (_.uniq(inputAnswer.value).length < inputAnswer.value.length) {
    setErrorMessage('重複した回答内容が存在しています')
    return
  }
  if (inputId.value === '')
    poll.newPoll(inputQuestion.value, inputAnswer.value)
  else
    poll.editPoll(inputQuestion.value, inputAnswer.value, inputId.value)

  resetInput()
}
</script>

<template>
  <div
    class="bg-white dark:bg-neutral-900 p-4 border-2 border-blue-400 rounded-lg absolute translate-x--1/2 translate-y--1/2 top-1/2 left-1/2 text-lg w-4/5 z-10"
  >
    <label for="questionText">質問内容</label>
    <input id="questionText" v-model="inputQuestion" type="text" class="input mb-3 mt-1">
    <label for="questionAns" class="mb-[-0.5rem]">回答内容</label>
    <div v-for="(_, i) in inputAnswer" :key="i" class="flex items-center mt-1">
      <div class="flex-1">
        <input v-model="inputAnswer[i]" type="text" class="input">
      </div>
      <div class="flex gap-1 ml-2 w-12">
        <button
          v-if="i === inputAnswer.length - 1"
          class="border rounded-full w-6 h-6 flex justify-center items-center"
          @click="addField"
        >
          +
        </button>
        <button
          v-if="inputAnswer.length > 2"
          class="border rounded-full w-6 h-6 flex justify-center items-center"
          @click="() => removeField(i)"
        >
          -
        </button>
      </div>
    </div>
    <p class="text-red-600 text-sm mt-2">
      {{ errorMessage }}
    </p>
    <div class="flex">
      <button class="bg-blue-500 px-4 py-1 rounded text-white ml-auto" @click="submit">
        決定
      </button>
    </div>
  </div>
</template>

<style scoped>
.input {
  @apply py-2 px-3 rounded-lg border w-full dark:bg-neutral-700;
}
</style>
